<?php
/*
Plugin Name: Footer Widget Flyout
Plugin URI: http://www.wpwox.com
Description: WPWOX Footer Flyout Widget provides you with a fully customizable sidebar where you can add widgets and display them in the pages as a flyout.
Version: 1.1
Author: WP WOX
Author URI: http://www.wpwox.com

Copyright 2015 WpWox

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//Get the plugin location.
define( 'WPWOXFOOTERWIDGETFLYOUT_VERSION', '1.1' );
define( 'WPWOXFOOTERWIDGETFLYOUT__PLUGIN_URL', plugin_dir_url( __FILE__ ) );
define( 'WPWOXFOOTERWIDGETFLYOUT__PLUGIN_DIR', plugin_dir_path( __FILE__ ) );

//**Hook the_content to output the scripts added to the page or post.

add_action('wp_footer', 'wpwoxfooterflyout_display_div');

//add admin menu
add_action( 'admin_menu', 'wpwoxfooterflyout_menu' );
add_action( 'widgets_init', 'wpwox_footerflyoutwidget_create_sidebar' );
function wpwox_footerflyoutwidget_create_sidebar() {

  register_sidebar( array(
    'name'          => 'Footer Flyout Sidebar',
    'id'            => 'wpwox-footer-flyout-div',
    'before_widget' => '<div>',
    'after_widget'  => '</div>',
    'before_title'  => '<h2 class="wpwox-footer-flyout-widgettitle">',
    'after_title'   => '</h2>',
  ) );

}

function wpwoxfooterflyout_menu() {
  add_menu_page( 'Settings', 'Footer Widget Flyout', 'manage_options', 'footer_flyout_setting', 'footerflyout_plugin_options' );
}

function footerflyout_plugin_options() {
  if ( !current_user_can( 'manage_options' ) )  {
    wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
  }
  if ( count($_POST) > 0 && isset($_POST['footerflyout_settings']) )
  {

  $options = array ('wpwoxfooterflyout_custom_heading' , 'wpwoxfooterflyout_headingonly' , 'wpwoxfooterflyout_radio_left', 'wpwoxfooterflyout_custom_width', 'wpwoxfooterflyout_custom_height','wpwoxfooterflyout_button_color',
  'wpwoxfooterflyout_text_color', 'wpwoxfooterflyout_background_color','wpwoxfooterflyout_mobile',
  'wpwoxfooterflyout_button_backgroundcolor', 'wpwoxfooterflyout_button_hovercolor', 
  'wpwoxfooterflyout_button_hoverbackgroundcolor','wpwoxfooterflyout_link_color',
  'wpwoxfooterflyout_custom_css','wpwoxfooterflyout_animation' );
    foreach ( $options as $opt )
    {
      //$opt= base64_encode($opt);
      delete_option ( $opt, $_POST[$opt] );
      add_option ( $opt, $_POST[$opt] ); 
    }     
  }
  echo '<div class="wrap">';
    wpwoxfooterflyout_metaboxs();
  echo '</div>';

}

//include css and js
function theme_name_scripts() {
  wp_enqueue_style( 'footer_flyout_plugin_css', WPWOXFOOTERWIDGETFLYOUT__PLUGIN_URL. '/wpwox-css.css' );
  wp_enqueue_script( 'footer_flyout_plugin_js', WPWOXFOOTERWIDGETFLYOUT__PLUGIN_URL . '/wpwox-js.js', array(), '1.0.0', true );
}

add_action( 'wp_enqueue_scripts', 'theme_name_scripts' );



function wpwoxfooterflyout_display_hook_footer() {
  global $post;
    if(is_single() || is_page()) {

echo html_entity_decode(get_post_meta($post->ID, '_wpwoxfooterflyoutcontentinfooter', true));
}
return;
}


//Displays a box that allows users to insert the scripts for the post or page
function wpwoxfooterflyout_metaboxs() {


  // Use nonce for verification
  wp_nonce_field( plugin_basename( __FILE__ ), 'wpwox_noncename' );



  ?>
  <style type="text/css">
  label{
    display: inline-block;
    clear: left;
    text-align: left;
    width: 200px;
    vertical-align: top;
    padding: 5px 0;
  }
  input[type="text"], textarea {
    margin-left: 5px;
  }
  .radiobtn{
    width: 50px;
    clear: both;
    display: inline;
    margin-right: 50px;
  }

  .radiolabel{
    width: 100%;
  }

  textarea{
    width:300px;
    height: 150px;
  }

  </style>
  <h2>Footer Flyout Widget Settings</h2>
    <form method="post" name="footerflyout">
      <label class="radiolabel"><?php _e('Position of the flyout','wpwoxfooterflyout') ?></label><br />
     
      <input type="radio" value="left" name="wpwoxfooterflyout_radio_left" id="left" <?php if(get_option('wpwoxfooterflyout_radio_left')!='right' ) {echo "checked = checked";} ?>><label for="left" class="radiobtn">Left</label>
      <input type="radio" value="right" name="wpwoxfooterflyout_radio_left" id="right" <?php if(get_option('wpwoxfooterflyout_radio_left')=='right'){echo "checked = checked";} ?>><label for="right" class="radiobtn">Right</label>

      <br/>

      <label class="radiolabel"><?php _e('Enable Heading Button') ?><small>(Enable this to show heading at first and then upon click, the widget content shows up)</small></label><br />
      <input type="radio" value="yes" name="wpwoxfooterflyout_headingonly" id="yes" <?php if(get_option('wpwoxfooterflyout_headingonly')=='yes'){echo "checked = checked";} ?>><label for="yes" class="radiobtn">Yes</label>
      <input type="radio" value="no" name="wpwoxfooterflyout_headingonly" id="no" <?php if(get_option('wpwoxfooterflyout_headingonly')!='yes'){echo "checked = checked";} ?>><label for="no" class="radiobtn">No</label>
     
      <br/>

      <label class="radiolabel"><?php _e('Show the flyout on mobile screen','wpwoxfooterflyout') ?></label><br />
      <input type="radio" value="yes" name="wpwoxfooterflyout_mobile" id="yes" <?php if(get_option('wpwoxfooterflyout_mobile')!='no'){echo "checked = checked";} ?>><label for="yes" class="radiobtn">Yes</label>
      <input type="radio" value="no" name="wpwoxfooterflyout_mobile" id="no" <?php if(get_option('wpwoxfooterflyout_mobile')=='no'){echo "checked = checked";} ?>><label for="no" class="radiobtn">No</label>
     
      <br/>

      <label class="radiolabel"><?php _e('Disable animation','wpwoxfooterflyout') ?></label><br />
      <input type="radio" value="yes" name="wpwoxfooterflyout_animation" id="yes" <?php if(get_option('wpwoxfooterflyout_animation')=='yes'){echo "checked = checked";} ?>><label for="yes" class="radiobtn">Yes</label>
      <input type="radio" value="no" name="wpwoxfooterflyout_animation" id="no" <?php if(get_option('wpwoxfooterflyout_animation')!='yes'){echo "checked = checked";} ?>><label for="no" class="radiobtn">No</label>
     <br/>
      <br/>

      <label for="wpwoxfooterflyout_text_color"><?php _e('Text Color') ?></label>
      <input id="wpwoxfooterflyout_text_color" name="wpwoxfooterflyout_text_color" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_text_color'); ?>"/><?php _e('(Eg. #000000)') ?>

      <br/>

      <label for="wpwoxfooterflyout_link_color"><?php _e('Link and Heading Color') ?></label>
      <input id="wpwoxfooterflyout_link_color" name="wpwoxfooterflyout_link_color" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_link_color'); ?>"/><?php _e('(Eg. #000000)') ?>

      <br/>

      <label for="wpwoxfooterflyout_background_color"><?php _e('Background Color') ?></label>
      <input id="wpwoxfooterflyout_background_color" name="wpwoxfooterflyout_background_color" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_background_color'); ?>"/><?php _e('(Eg. #cccccc)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_button_color"><?php _e('Button Color') ?></label>
      <input id="wpwoxfooterflyout_button_color" name="wpwoxfooterflyout_button_color" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_button_color'); ?>"/><?php _e('(Eg. #ff0000)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_button_backgroundcolor"><?php _e('Button Background Color') ?></label>
      <input id="wpwoxfooterflyout_button_backgroundcolor" name="wpwoxfooterflyout_button_backgroundcolor" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_button_backgroundcolor'); ?>"/><?php _e('(Eg. #E83D2C)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_button_hovercolor"><?php _e('Button Hover Color') ?></label>
      <input id="wpwoxfooterflyout_button_hovercolor" name="wpwoxfooterflyout_button_hovercolor" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_button_hovercolor'); ?>"/><?php _e('(Eg. #ffff00)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_button_hoverbackgroundcolor"><?php _e('Button Hover Background Color') ?></label>
      <input id="wpwoxfooterflyout_button_hoverbackgroundcolor" name="wpwoxfooterflyout_button_hoverbackgroundcolor" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_button_hoverbackgroundcolor'); ?>"/><?php _e('(Eg. #ffffff)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_custom_height"><?php _e('Custom Height') ?></label>
      <input id="wpwoxfooterflyout_custom_height" name="wpwoxfooterflyout_custom_height" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_custom_height'); ?>"/><?php _e('(Eg. 300px)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_custom_width"><?php _e('Custom Width') ?></label>
      <input id="wpwoxfooterflyout_custom_width" name="wpwoxfooterflyout_custom_width" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_custom_width'); ?>"/><?php _e('(Eg. 250px)') ?>
      
      <br/>

      <label for="wpwoxfooterflyout_custom_heading"><?php _e('Custom Heading') ?></label>
      <input id="wpwoxfooterflyout_custom_heading" name="wpwoxfooterflyout_custom_heading" type="text" value="<?php 
      echo get_option('wpwoxfooterflyout_custom_heading'); ?>"/><?php _e('(Eg. Custom Heading)') ?>

      <br/>

      <label for="wpwoxfooterflyout_custom_css"><?php _e('Custom CSS') ?></label>
      <textarea id="wpwoxfooterflyout_custom_css" name="wpwoxfooterflyout_custom_css"><?php 
      echo get_option('wpwoxfooterflyout_custom_css'); ?></textarea>

      <p class="submit">
          <input type="submit" name="Submit" class="button-primary" value="Save Changes" />
          <input type="hidden" name="footerflyout_settings" value="save" style="display:none;" />
      </p>

    </form>

    <p> To read full documentation about this plugin please visit <a href="http://www.wpwox.com/footer-flyout-widget/">WPWOX Footer Flyout Widget</a></p>



    <?php
}

function wpwoxfooterflyout_display_div(){

  $wpwoxcustomheading= get_option('wpwoxfooterflyout_custom_heading');
  $wpwoxcustomheadingonly = get_option('wpwoxfooterflyout_headingonly');
  $widgetflyout = get_option('wpwoxfooterflyout_radio_left');
  $mobiledisplay = get_option('wpwoxfooterflyout_mobile');
  $backgroundcolor = get_option('wpwoxfooterflyout_background_color');
  $textcolor = get_option('wpwoxfooterflyout_text_color');
  $linkcolor = get_option('wpwoxfooterflyout_link_color');
  $buttoncolor = get_option('wpwoxfooterflyout_button_color');
  if(get_option('wpwoxfooterflyout_custom_height')<> null){
  $customheight = get_option('wpwoxfooterflyout_custom_height')-40;}

  if(get_option('wpwoxfooterflyout_custom_width')<> null){
  $customwidth = get_option('wpwoxfooterflyout_custom_width')-40;}
  else $customwidth = "300";
  $buttonbackgroundcolor = get_option('wpwoxfooterflyout_button_backgroundcolor');
  $buttonhovercolor = get_option('wpwoxfooterflyout_button_hovercolor');
  $buttonhoverbackgroundcolor = get_option('wpwoxfooterflyout_button_hoverbackgroundcolor');
  $customcss= get_option('wpwoxfooterflyout_custom_css');
  $transistion = get_option('wpwoxfooterflyout_animation');

  if($transistion=="no"){
    echo "<style>";
     echo "";
    echo "</style>";
  }

  if($customcss){
    echo "<style>";
    echo $customcss;
    echo "</style>";
  }

  if($backgroundcolor){

add_action('wp_footer','hook_css');

function hook_css() {

  $output="<style> #wpwox-footer-flyout-div{background-color:$backgroundcolor !important;}</style>";

  echo $output;

}
    echo "<style>";
    echo "#wpwox-footer-flyout-div{background-color:$backgroundcolor !important;}";
    echo "</style>";
  }

  if($textcolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-div{color:$textcolor !important;}h4#wpwox-footer-flyout-customheading{color:$textcolor !important;}";
    echo "</style>";
  }

  if($textcolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-div a{color:$linkcolor !important;}h4#wpwox-footer-flyout-customheading{color:$linkcolor !important;}";
    echo "</style>";
  }

  if($mobiledisplay=="no"){
    echo "<style>";
    echo "@media(max-width:400px){
#wpwox-footer-flyout-div{
    display: none !important;
}";
    echo "</style>";
  }

  if($customheight){
     echo "<style>";
    echo "#wpwox-footer-flyout-headingonly{height:$customheight"."px"." !important;}";
    echo "</style>";
  }

  if($customwidth){
     echo "<style>";
    echo "#wpwox-footer-flyout-div{width:$customwidth"."px"."!important;}";
    echo "</style>";
  }
 

 if($widgetflyout=='right'){
  echo "<style>";
   echo "#wpwox-footer-flyout-div{
    right:0; 
    border-radius: 22px 0px 0px 0px;
    -moz-border-radius: 22px 0px 0px 0px;
    -webkit-border-radius: 22px 0px 0px 0px;
    border: 0px none #000000;}
    #wpwox-footer-flyout-closebtn{left: -6px;}";
  echo "</style>";
 }


  
  echo "<div id='wpwox-footer-flyout-div' class='wpwox-footer-flyout-div'>";

   if($buttoncolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-closebtn{color: $buttoncolor; !important}";
    echo "</style>";
  }

  if($buttonbackgroundcolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-div #wpwox-footer-flyout-closebtn{background-color: $buttonbackgroundcolor !important;}";
    echo "</style>";
  }

  if($buttonhovercolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-closebtn: hover{color: $buttonhovercolor !important;}";
    echo "</style>";
  }

  if($buttonhoverbackgroundcolor){
    echo "<style>";
    echo "#wpwox-footer-flyout-div #wpwox-footer-flyout-closebtn:hover{background-color: $buttonhoverbackgroundcolor !important;}";
    echo "</style>";
  }


  if( $wpwoxcustomheading
 ){
    if($wpwoxcustomheadingonly=='yes'){
      echo "<h4 id='wpwox-footer-flyout-customheading'>";
      echo $wpwoxcustomheading;
      echo "</h4>";

      echo "<style>
                    
                    #wpwox-footer-flyout-headingonly{
                        display: none;
                     }
            </style>";
      echo '<button id="wpwox-footer-flyout-closebtn" class="wpwox-footer-flyout-inactive">X</button>';
      echo "<div id='wpwox-footer-flyout-headingonly'>";
      dynamic_sidebar('wpwox-footer-flyout-div');
      echo "</div>";
    }
    else{
       withoutheading();
    }

  }
  else{
    withoutheading();
  }
 
  echo '</div>';
  }

  function withoutheading(){
    echo '<button id="wpwox-footer-flyout-closebtn" style="opacity:1">X</button>';

    dynamic_sidebar('wpwox-footer-flyout-div');
    echo  "<script>";
    echo 'jQuery("#wpwox-footer-flyout-closebtn").click(function(){ ';
    echo 'jQuery("#wpwox-footer-flyout-div").removeClass("wpwox-footer-flyout-active");';
    echo 'jQuery("#wpwox-footer-flyout-div").addClass("wpwox-footer-flyout-inactive");';
    echo ' });';
    echo "</script>";
  }
?>